<?php
require_once 'lib/elearning/clients/xml_rpc_webservice_client.php';

require 'lib/edubreak_connect.php';
require 'lib/models.php';


class EdubreakPlugin extends StudipPlugin implements StandardPlugin {

	public $config = array();

	function __construct() {

		parent::__construct();

		$this->restoreConfig();
        $this->me = strtolower(__CLASS__);

        if (Navigation::hasItem('/course') && PluginManager::getInstance()->isPluginActivated($this->getPluginId(), $_SESSION['SessSemName'][1])) {
            $start_nav = new Navigation($this->getDisplaytitle());
            Navigation::addItem("/course/$this->me", $start_nav);

            $navigation = new AutoNavigation($this->getDisplayTitle());
            $navigation->setURL(PluginEngine::getURL("$this->me/show"));
            Navigation::addItem("/course/$this->me/show", $navigation);
        }


        }

	function getDisplayTitle(){
		return $this->config['displayname'] ? $this->config['displayname'] : $this->getPluginName();
	}

	function restoreConfig(){


		$config = DBManager::get()
				->query("SELECT comment FROM config WHERE field = 'CONFIG_" . $this->getPluginName() . "' AND is_default=1")
				->fetchColumn();
		$this->config = unserialize($config);

		foreach(Config::get()->getFields('global', null, 'EDUBREAK') as $field) {
	        $this->config[$field] = Config::get()->getValue($field);
	    }
		return $this->config != false;
	}

	function storeConfig(){
		$config = serialize($this->config);
		$field = "CONFIG_" . $this->getPluginName();
		$st = DBManager::get()
		->prepare("REPLACE INTO config (config_id, field, value, is_default, `type`, `range`, chdate, comment)
			VALUES (?,?,'do not edit',1,'string','global',UNIX_TIMESTAMP(),?)");
		return $st->execute(array(md5($field), $field, $config));
	}


	public function getIconNavigation($course_id, $last_visit)
	{
	    return null;
	}

	public function getInfoTemplate($course_id)
	{
	    return null;
	}

	/**
	* This method dispatches and displays all actions. It uses the template
	* method design pattern, so you may want to implement the methods #route
	* and/or #display to adapt to your needs.
	*
	* @param  string  the part of the dispatch path, that were not consumed yet
	*
	* @return void
	*/
    function perform($unconsumed_path) {
        if(!$unconsumed_path){
            header("Location: " . PluginEngine::getUrl($this), 302);
            return false;
        }
        $trails_root = $this->getPluginPath();
        $dispatcher = new Trails_Dispatcher($trails_root, null, 'show');
        $dispatcher->current_plugin = $this;
        $dispatcher->dispatch($unconsumed_path);
    }
}
