<?php
require 'application.php';

class ShowController extends ApplicationController {

    function before_filter($action, $args) {

        parent::before_filter($action, $args);

        if ($this->plugin->config['EDUBREAK_HOST'] && $this->plugin->config['EDUBREAK_APP_KEY'] && $this->plugin->config['EDUBREAK_APP_SECRET']) {
            $this->rpc = new edubreakConnector($this->plugin->config['EDUBREAK_HOST'], $this->plugin->config['EDUBREAK_APP_KEY'],$this->plugin->config['EDUBREAK_APP_SECRET'],0);
        } else {
            $this->flash_now('error',_("Die Verbindungseinstellungen fr Edubreak sind nicht gesetzt! Bitte wenden Sie sich an die Administration."));
            $this->render_template('show/index.php', $this->layout);
        }
        Navigation::activateItem("/course/".$this->plugin->me."/show");
        $this->course_id = $_SESSION['SessSemName'][1];
    }

	function index_action()
	{
	    ob_start();
        $this->connect();
        $this->user = edubreakAuthExtern::find($GLOBALS['user']->id);
        $this->course = edubreakObjectContentModule::find($this->course_id);

        $edu_user = $this->getEdubreakUser();

        if (Request::get('create')) {
            if (!$edu_user) {
                $this->flash_now('error', _("Ihr Edubreak Account konnte nicht angelegt werden."));
            } else {
                $edu_course = $this->getEdubreakCourse();
                if (!$edu_course) {
                    $this->flash_now('error', _("Ihr Edubreak Kurs konnte nicht angelegt werden."));
                }
            }
        }
        if (!$this->course->module_id) {
            if ($GLOBALS['perm']->have_studip_perm('tutor' , $this->course_id)) {
                $this->question = createQuestion(_("Fr diesen Stud.IP Kurs existiert noch kein EduBreak Kurs. Mchten Sie jetzt einen Kurs anlegen?"), array('create' => 1), array() ,$this->url_for());
            }
            $this->flash_now('info', _("Fr diesen Stud.IP Kurs existiert noch kein EduBreak Kurs."));
        } else {
            $this->members = $this->refreshCourseMembers();
            $this->course = edubreakObjectContentModule::find($this->course_id);
            $this->user = edubreakAuthExtern::find($GLOBALS['user']->id);
            if ($this->user->external_user_name) {
                $this->link = $this->getEdubreakLink();
            } else {
                $this->flash_now('error', _("Ihr Edubreak Account konnte nicht angelegt werden."));
            }
        }
        $log = ob_get_clean();
        if ($log) {
            $this->flash_now('error','edubreak_connect:', array($log));
        }

	}

	function refreshCourseMembers()
	{
	    $sem = Seminar::getInstance($this->course_id);
	    $edu_members = array();
	    $edu_course = $this->getEdubreakCourse();
	    $members = $sem->getMembers('dozent') + $sem->getMembers('tutor') + $sem->getMembers('autor');
	    if ($GLOBALS['perm']->have_perm('admin')) {
	        $members[] = array('user_id' => $GLOBALS['user']->id, 'username' => get_username());
	    }
	    foreach($members as $member) {
	        $studipuser = edubreakAuthExtern::find($member['user_id']);
	        if (!$studipuser) {
	            $studipuser = new edubreakAuthExtern($member['user_id']);
	            $studipuser->external_user_name = '';
	            $studipuser->external_user_password = md5(uniqid());
	            $studipuser->store();
	        }
	        $edu_member = $this->getEdubreakUser($studipuser);
	        $this->rpc->addMemberToCourse($edu_course, $edu_member);
            if ($edu_member->ecuid) {
                $studipuser->external_user_name = $edu_member->ecuid;
                $studipuser->store();
                $edu_members[] = array_merge($member, $studipuser->toArray());
            }
	    }
	    return $edu_members;
	}

	function getEdubreakUser($studipuser = null)
	{

	    $mail = '';
	    $pic = 'tolles Bildchen';

	    if (!$studipuser) {
	        if (!$this->user) {
	            //$this->connect();
	            //$edu_user = new edubreakUser($GLOBALS['user']->id, get_username(), md5(uniqid()), '', '', $GLOBALS['perm']->have_studip_perm('dozent' , $this->course_id));
	            //if ($edu_user = $this->rpc->createUser($edu_user)) {
	            $user = new edubreakAuthExtern($GLOBALS['user']->id);
	            $user->external_user_name = '';//$edu_user->ecid;
	            $user->external_user_password = md5(uniqid());//$edu_user->pass;
	            if (!$user->store()) {
	                $edu_user = null;
	            } else {
	                $this->user = $user;
	            }
	            //}
	        }
	        if ($this->user) {
	            $current_user = AuthUserMd5::find($GLOBALS['user']->id);
	            $edu_user = new edubreakUser($current_user->user_id, $current_user->username, $this->user->external_user_password, $current_user->email, $pic, $GLOBALS['perm']->have_studip_perm('dozent' , $this->course_id,$current_user->user_id ), $this->user->external_user_name);
	        }
	    } else {
	       $current_user = AuthUserMd5::find($studipuser->studip_user_id);
	       $edu_user = new edubreakUser($studipuser->studip_user_id,  $current_user->username, $studipuser->external_user_password, $current_user->email, $pic, $GLOBALS['perm']->have_studip_perm('dozent' , $this->course_id,$current_user->user_id), $studipuser->external_user_name);
	    }
	    return $edu_user;
	}

	function getEdubreakCourse()
	{
	    $sem = Seminar::getinstance($this->course_id);
	    if(!$this->course->module_id) {
	        $edu_course = new edubreakCourse($sem->name, $sem->description ? $sem->description : 'n.a.');
	        $this->rpc->createCourse($edu_course);
	        if ($edu_course->eccid) {
	            $course = new edubreakObjectContentModule(array($sem->getId(), $edu_course->eccid));
	            if (!$course->store()) {
	                $edu_course = null;
	            } else {
	                $this->course = $course;
	            }
	        }
	    } else {
	        $edu_course = new edubreakCourse($sem->name, $sem->description ? $sem->description : 'n.a.', $this->course->module_id);
	    }
	    return $edu_course;
	}

	function getConnectedUser($user_id)
	{
	}

	function getEdubreakLink() {
	    return $this->rpc->createLoginUrl($this->getEdubreakUser());
	}

	function connect()
	{
	    if (!$this->rpc->connect()) {
	        throw new Exception("Edubreak connect nicht erfolgreich");
	    }
	    return true;

	}
}

